/* Compile using "gcc -Wall -O2 -o lynx-chg2html lynx-chg2html.c" */

#include <stdio.h>
#include <stdlib.h>

#include <string.h>

#define MAX	32767

char *Month(char *Number)
{
    switch (atoi(Number)) {
	case  1:	return "Jan";
	case  2:	return "Feb";
	case  3:	return "Mar";
	case  4:	return "Apr";
	case  5:	return "May";
	case  6:	return "Jun";
	case  7:	return "Jul";
	case  8:	return "Aug";
	case  9:	return "Sep";
	case 10:	return "Oct";
	case 11:	return "Nov";
	case 12:	return "Dec";
	default:	return "???";
    }
}

void GetLine( char **Buffer )
{
    char *Ptr = *Buffer;
    char *Old, *New;

    *Ptr = '\0';
    fgets( Ptr, MAX, stdin );
    if (*Ptr != '\0') {
	Ptr = index(*Buffer,'\n');
	*Ptr++ = '\0';
	New = *Buffer;
	Old = Ptr = strcpy(Ptr+100,New);
	while (*Old != '\0') {
	    *New = '\0';
	    switch (*Old) {
		case '<':
		    *New++ = '&';
		    *New++ = 'l';
		    *New++ = 't';
		    *New++ = ';';
		    Old++;
		    break;
		case '>':
		    *New++ = '&';
		    *New++ = 'g';
		    *New++ = 't';
		    *New++ = ';';
		    Old++;
		    break;
		default:
		    *New++ = *Old++;
		    break;
	    }
	}
	*New = *Old;
    }
}

void main(void)
{
    char *Line = (char *) malloc(MAX+1);
    char *Ptr, *Ptr2, Flag = (char) -1;

    GetLine( &Line );
    for (Ptr=Line; index(" -",*Ptr)!=NULL; Ptr++)
	/* Do nothing */;
    Ptr2 = strdup(Ptr);
    (void) strcpy( Line, Ptr2 );
    free( Ptr2 );
    if ( (Ptr = Ptr2 = rindex(Line,'(')) != NULL) {
	while (*--Ptr2 == ' ')
	    *Ptr2 = '\0';
	printf( "<HTML>\n<HEAD>\n\n<TITLE>%s</TITLE>\n\n</HEAD>\n<BODY>\n\n<CENTER>\n\n<H1>%s</H1>\n\n<H2>%s</H2>\n\n</CENTER>\n\n",
		Line, Line, Ptr );
    } else
	printf( "<HTML>\n<HEAD>\n\n<TITLE>%s</TITLE>\n\n</HEAD>\n<BODY>\n\n<CENTER>\n\n<H1>%s</H1>\n\n</CENTER>\n\n",
		Line, Line );
    (void) fgets( Line, MAX, stdin );
    Ptr = Line + 2;
    while (!feof(stdin)) {
	GetLine( &Line );
	if ( (Ptr = index(Line,'\n')) != NULL)
	    *Ptr-- = '\0';
	switch (*Line) {
	    case ' ':
		printf( "%s\n", Line+2 );
		break;
	    case '*':
		printf( "\n<P><LI>%s\n", Line+2 );
		break;
	    case '=':
		break;
	    case '-':
		Ptr = rindex(Line,' ');
		while (index(" -",*Ptr) != NULL)
		    *Ptr-- = '\0';
		Ptr = Line;
		while (index("- ",*Ptr) != NULL)
		    *Ptr++ = '\0';
		Ptr2 = strdup(Ptr);
		(void) strcpy( Line, Ptr2 );
		free( Ptr2 );
		if ( (Ptr = Ptr2 = rindex(Line,'(')) != NULL) {
		    while (*--Ptr2 == ' ')
			*Ptr2 = '\0';
		    printf( "<BR>\n\n<CENTER>\n\n<H1>%s</H1>\n\n<H2>%s</H2>\n\n</CENTER>\n\n", Line, Ptr );
		} else
		    printf( "<BR>\n\n<CENTER>\n\n<H1>%s</H1>\n\n</CENTER>\n\n<HR>\n\n", Line );
		break;
	    case '0':
	    case '1':
	    case '2':
	    case '3':
	    case '4':
	    case '5':
	    case '6':
	    case '7':
	    case '8':
	    case '9':
		Ptr = Line + 100;
		if (Line[2] == '-') {
		    Line[2] = Line[5] = '\0';
		    if (*Line == '9')
			sprintf( Ptr, "%2s %3s 19%2s</B><BR>\n\n<UL>\n\n", Line+6, Month(Line+3), Line );
		    else
			sprintf( Ptr, "%2s %3s 19%2s</B><BR>\n\n<UL>\n\n", Line+3, Month(Line), Line+6 );
		} else {
		    Line[4] = Line[7] = '\0';
		    sprintf( Ptr, "%2s %3s %2s</B><BR>\n\n<UL>\n\n", Line+8, Month(Line+5), Line );
		}
		if (*Ptr == '0')
		    Ptr++;
		if (Flag) {
		    printf( "<P><B>%s", Ptr );
		    Flag = 0;
		    break;
		} else
		    printf( "\n</UL>\n\n<P><B>%s", Ptr );
	    case '\0':
		break;
	}
    }
    printf( "\n</BODY>\n</HTML>\n" );
}
